#!/usr/bin/env python3
import subprocess
import sys

from systemd import journal

has_vpp = False
LINKST_IDX = 6
DATANM_IDX = 4
PLUGIN_IDX = 3
UPDOWN_IDX = 9
UPDOWNTOOL = '/scripts/eth_up_down_vpplauncher.sh'

valid_list = ['data', 'vhu', 'tap']
ifmatchstr = 'PluginInstance: '
#
eth_up_down_stream = journal.stream(identifier='eth_up_down')
#
lines = sys.stdin.readlines()
if (1 <= lines[PLUGIN_IDX].find("vpp_events")):
    has_vpp = True
    UPDOWN_IDX = 8

updownstr = lines[UPDOWN_IDX]
if len(lines) > 10 and -1 < lines[8].find("iface-id"):
    updownstr = lines[10]
elif len(lines) > 11 and -1 < lines[9].find("iface-id"):
    updownstr = lines[11]

if 1 <= lines[LINKST_IDX].find("link_status") \
   and (1 <= lines[PLUGIN_IDX].find("_events")) \
   and -1 < lines[DATANM_IDX].find(ifmatchstr):
    data_name = lines[DATANM_IDX][lines[DATANM_IDX].find(ifmatchstr) + len(ifmatchstr):len(lines[DATANM_IDX]) - 1]
    found = False
    for goodif in valid_list:
        if data_name.startswith(goodif):
            found = True
            break

    if not found:
        print("{} ignore {}".format(lines[1].strip(), data_name), file=eth_up_down_stream)
        exit(0)

    print("{} processing {}".format(lines[1].strip(), data_name), file=eth_up_down_stream)
    if 1 <= updownstr.find("UP"):
        print("{} {} UP".format(lines[1].strip(), data_name), file=eth_up_down_stream)

        try:
            subprocess.run([UPDOWNTOOL, data_name, 'UP'])
        except Exception as e:
            print("Fail, Error : {}".format(e), file=eth_up_down_stream)
            pass
    elif 1 <= updownstr.find("DOWN") and data_name.startswith('data') and not '.' in data_name:
        print("{} {} DOWN".format(lines[1].strip(), data_name), file=eth_up_down_stream)

        try:
            subprocess.run([UPDOWNTOOL, data_name, 'DOWN'])
        except Exception as e:
            print("Fail, Error : {}".format(e), file=eth_up_down_stream)
            pass
    else:
        print("eth_up_down error - updownstr unknown or interface name doesn't contain \'data\'",
              file=eth_up_down_stream)
